include	<time.h>
include	"ftab.h"


## FTC_SETUP: Generic, type-independent setup code

procedure ftc_setup (kdat, type, form, unit, null, wid, fmtstr, fmtstrlen, typefmt, sppfmt)

pointer	kdat				# pointer to struct
char	type[ARB]			# field name
char	form[ARB]			# format string for column
char	unit[ARB]			# field units
pointer	null				# null value (addr just gets passed)
int	wid				# width of field (TMP?)

char	fmtstr[ARB]
int	fmtstrlen
int	typefmt				# type of format (fixed, float, char)
char	sppfmt[16]

int	ndx

int	strlen()
begin
	ndx = TFIELD(kdat)
	if (ndx + 1 > TMAXCOL(kdat))
		call fatal (0, "ftcol_def: more columns defined than requested")

	if (strlen (form) >= TFMTLEN)
		call fatal (0, "ftcol_def: format string too long")
	if (strlen (type) >= TTYPLEN)
		call fatal (0, "ftcol_def: type string too long")
	if (strlen (unit) >= TUNILEN)
		call fatal (0, "ftcol_def: unit string too long")

	TFIELD(kdat) = TFIELD(kdat) + 1
	TBCOL(kdat,ndx) = TWUSED(kdat) + 1
	TWUSED(kdat) = TWUSED(kdat) + wid

# translate format string
	if (form[1] == 'A' || form[1] == 'a') {
		call sprintf (sppfmt, 16, "%%-%ss")
			call pargstr (form[2])
		typefmt = FT_CHAR
	} else if (form[1] == 'I' || form[1] == 'i') {
		call sprintf (sppfmt, 16, "%%%sd")
			call pargstr (form[2])
		typefmt = FT_FIXED
	} else if (form[1] == 'F' || form[1] == 'f') {
		call sprintf (sppfmt, 16, "%%%sf")
			call pargstr (form[2])
		typefmt = FT_FLOAT
	} else if (form[1] == 'E' || form[1] == 'e') {
		call sprintf (sppfmt, 16, "%%%sg")
			call pargstr (form[2])
		typefmt = FT_FLOAT
	} else {
		call fatal (0, "ftcol_def:  no translation for format type")
	}

	if (strlen (fmtstr) + strlen (sppfmt) > fmtstrlen) {
		call fatal (0, "requested format string too long!")
	}

	call strcat (sppfmt, fmtstr, fmtstrlen)
end
